/*           Install the Audio-CD-Folder/Data-CD-Folder 
 *
 *                   (C) Chris Wohlgemuth 1999-2001
*/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

 call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
 call SysLoadFuncs

/* Get curent directory */
curdir = directory()

/* Clear screen */
/*'cls'*/
pmconfig.exe
say 'rc: 'RC

if rc\=0 then exit

say 'Current directory is' curdir
say ''

say 'Registering class ''CWProgFolder''...'

if SysRegisterObjectClass("CWProgFolder",'progfldr')<>1 then
	do	 	
                say ''
		say 'Error while registering class ''CWProgFolder'''
		del boot
		say 'Exiting...'
		exit 	
	end 

audiofolderdll=curdir'\aucdfldr.dll'

say 'Registering class ''CWAudioFolder''...'
if SysRegisterObjectClass("CWAudioFolder",audiofolderdll)<>1 then
	do	 	
                say ''
		say 'Error while registering class ''CWAudioFolder'''
		say 'Deregistering class ''CWProgFolder'''
		if SysDeregisterObjectClass("CWProgFolder") <>1 then
			say 'Error while deregistering class ''CWProgFolder'''
		del boot
		say 'Exiting...'
		say 'After reboot delete file 'boot
		exit 	
	end 

say 'Registering class ''CWDataFolder''...'
if SysRegisterObjectClass("CWDataFolder",audiofolderdll)<>1 then
	do	 	
                say ''
		say 'Error while registering class ''CWDataFolder'''
		say 'Deregistering class ''CWAudioFolder'''
		if SysDeregisterObjectClass("CWAudioFolder") <>1 then
			say 'Error while deregistering class ''CWAudioFolder'''
		say 'Deregistering class ''CWProgFolder'''
		if SysDeregisterObjectClass("CWProgFolder") <>1 then
			say 'Error while deregistering class ''CWProgFolder'''
		del boot
                del audiofolderdll
		say 'Exiting...'
		say 'After reboot delete file 'boot
		exit 	
	end 

say 'Registering class ''CWCreatorSettings''...'
if SysRegisterObjectClass("CWCreatorSettings",audiofolderdll)<>1 then
	do	 	
                say ''
		say 'Error while registering class ''CWCreatorSettings'''
		say 'Deregistering class ''CWDataFolder'''
		if SysDeregisterObjectClass("CWDataFolder") <>1 then
			say 'Error while deregistering class ''CWDataFolder'''
		say 'Deregistering class ''CWAudioFolder'''
		if SysDeregisterObjectClass("CWAudioFolder") <>1 then
			say 'Error while deregistering class ''CWAudioFolder'''
		say 'Deregistering class ''CWProgFolder'''
		if SysDeregisterObjectClass("CWProgFolder") <>1 then
			say 'Error while deregistering class ''CWProgFolder'''
		del boot
                del audiofolderdll
		say 'Exiting...'
		say 'After reboot delete file 'boot
		exit 	
	end 


say 'Customizing the template in the templates folder...'
if SysCreateObject("CWAudioFolder","Create Audio-CD","<WP_TEMPS>","OBJECTID=<AUDIOCD_CREATOR>;TEMPLATE=YES;FLDRWRITEFLAGS=11;BACKGROUND="curdir"\Res\music.jpg,T,,I","update")<>1 then
             say '     Can''t update the template.'
if SysCreateObject("CWDataFolder","Create Data-CD","<WP_TEMPS>","OBJECTID=<DATACD_CREATOR>;TEMPLATE=YES;FLDRFILENAMEOPTIONS=31;FLDRCREATEOPTIONS=1;FLDRCDTYPEOPTIONS=520;BACKGROUND="curdir"\Res\DATACD.jpg,S,1,I","update")<>1 then
             say '     Can''t update the template.'


say 'Creating a CD-Writing folder on the desktop...'
setupstring='OBJECTID=<CD_WRITING>;ICONFILE='curdir'\Res\cdrfold1.ico;ICONNFILE=1,'curdir'\Res\cdrfold2.ico'
if SysCreateObject("WPFolder","CD-Writing Utilities","<WP_DESKTOP>",setupstring,"update")<>1 then
             do
                say ''
                say 'Can''t create the folder. Exciting...'
		say 'You''ll find a template in your templates folder.'
		exit
             end


setupstring='EXENAME='curdir'\cdrtools.exe;STARTUPDIR='curdir
say 'Creating an object for CDRTools...'
if SysCreateObject("WPProgram","CDR-Tools","<CD_WRITING>",setupstring,"update")<>1 then
		do
              say ''
              say 'Cannot create a program object for CDRTools.exe.'
              say 'You can find CDRTools in 'curdir
              say '' 
            end


say 'Creating a shadow for the documentation folder...'
setupstring='SHADOWID='curdir'\Docs'
if SysCreateObject("WPShadow","Docs","<CD_WRITING>",setupstring,"update")<>1 then
	do
              say 'Cannot create the shadow for the folder.'
	      say 'Perhaps on FAT-Drive not HPFS...'
	end


say 'Creating a shadow of the Audio-CD-Creator in the CD-Writing folder...'
if SysCreateObject("WPShadow","Create Audio-CD","<CD_WRITING>","OBJECTID=<ACD_SHADOW>;SHADOWID=<AUDIOCD_CREATOR>","update")<>1 then
              say 'Cannot create the shadow.'


say 'Creating a shadow of the Data-CD-Creator in the CD-Writing folder...'
if SysCreateObject("WPShadow","Create Data-CD","<CD_WRITING>","OBJECTID=<DCD_SHADOW>;SHADOWID=<DATACD_CREATOR>","update")<>1 then
              say 'Cannot create the shadow.'


setupstring='OBJECTID=<CWCREATOR_SETTINGS>'
say 'Creating CD-Creator Settings object...'
if SysCreateObject("CWCreatorSettings","CD-Creator Settings","<CD_WRITING>",setupstring,"update")<>1 then
		do
              say ''
              say 'Cannot create a CD-Creator Settings object'
              say '' 
            end

say 'Creating an object for the tutorial in the CD-Writing folder...'
setupstring='EXENAME=view.exe;PARAMETERS='curdir'\tutorial.inf;OPEN=DEFAULT;OBJECTID=<CWCREATOR_TUTORIAL>'
if SysCreateObject("WPProgram","CD writing tutorial","<CD_WRITING>",setupstring,"update")<>1 then
              say 'Can''t create the tutorial object.'


Say 'Creating Shadows for the CDRecord/2-, mkisofs- and cdda2wav docs...'
/* Get CDRecord/2 path */
cdrini=curdir'\cdrecord.ini'
cdrpath=SysIni(cdrini,'CDWriter','cdrecord')
/* Do we have a drive? */
cdrdrive=FILESPEC("drive",cdrpath)
if cdrdrive \='' then
DO
  target=curdir'\Docs'
  /* Build path to cdrecord.ps */
  cdrps=cdrdrive||FILESPEC("path",cdrpath)'doc\cdrecord.ps'
  setupstring='SHADOWID='cdrps
  if SysFileTree(cdrps,stamm,'F') =0 then 
  DO
    IF stamm.0=1 THEN  rc=SysCreateObject("WPShadow","cdrecord.ps",target,setupstring,"update")
  END

  mkisofsps=cdrdrive||FILESPEC("path",cdrpath)'doc\mkisofs.ps'
  setupstring='SHADOWID='mkisofsps
  if SysFileTree(mkisofsps,stamm,'F') =0 then
  DO
    IF stamm.0=1 THEN  rc=SysCreateObject("WPShadow","mkisofs.ps",target,setupstring,"update")
  END

  cdda2wavps=cdrdrive||FILESPEC("path",cdrpath)'doc\cdda2wav.ps'
  setupstring='SHADOWID='cdda2wavps
  if SysFileTree(cdda2wavps,stamm,'F') =0 then
  DO
    IF stamm.0=1 THEN  rc=SysCreateObject("WPShadow","cdda2wav.ps",target,setupstring,"update")
  END
END


setupstring='EXENAME='curdir'\bin\pmaudcpy.exe;OBJECTID=<CD_COPY>;ICONFILE='curdir'\Res\pmaudcpy.ico'
say 'Creating an object for 1:1 CD-Copy...'
if SysCreateObject("WPProgram","1:1 CD-Copy","<CD_WRITING>",setupstring,"update")<>1 then
		do
              say ''
              say 'Cannot create a program object for pmaudcpy.exe.'
              say 'You can find pmaudcpy.exe in 'curdir'\bin'
              say '' 
            end

/* Open the CD-writing folder */
rc=SysSetObjectData("<CD_WRITING>","OPEN=DEFAULT")



/*say ''
say 'The Audio-CD-Creator and Data-CD-Creator'
say 'were installed succesful.'
say 'You''ll find templates in your templates folder for creating'
say 'Audio-CD and Data-CD projects.'
say 'Before starting to write you have to enter the path to each helper'
say 'program in the settings notebook!'
say ''*/
say ''
say 'If you did an update installation it may be necessary to restart the WPS.'
say ''
say 'Have fun :-) !!'

say ''
say ''
say 'Press <ENTER>'
say ''
say '>'
parse value SysCurPos() with aktzeile aktspalte
newposition=SysCurPos(aktzeile-1,2)
pull

exit

